//!HOOK MAIN
//!BIND HOOKED
//!DESC ACES Filmic Tone Mapping (Hybrid)

vec3 aces(vec3 x) {
    const float A = 2.51;
    const float B = 0.03;
    const float C = 2.43;
    const float D = 0.59;
    const float E = 0.14;
    return (x * (A * x + B)) / (x * (C * x + D) + E);
}

float y(vec3 x) {
    // https://en.wikipedia.org/wiki/Relative_luminance
    return dot(x, vec3(0.2126, 0.7152, 0.0722));
}

vec4 color = HOOKED_texOff(vec2(0.0, 0.0));
vec4 hook() {
    const vec3 L = vec3(y(color.rgb));
    const vec3 lum = aces(L) / L * color.rgb;
    const vec3 rgb = aces(color.rgb);
    color.rgb = L.x > y(vec3(1.0)) ? rgb : lum;
    return color;
}
