//!HOOK MAIN
//!BIND HOOKED
//!DESC Hable Filmic Tone Mapping

vec3 uncharted2(vec3 x) {
    const float A = 0.15;   // Shoulder Strength
    const float B = 0.50;   // Linear Strength
    const float C = 0.10;   // Linear Angle
    const float D = 0.20;   // Toe Strength
    const float E = 0.02;   // Toe Numerator
    const float F = 0.30;   // Toe Denominator
    return ((x * (A * x + C * B) + D * E) / (x * (A * x + B) + D * F)) - E / F;
}

vec3 uncharted2_main(vec3 x) {
    const float W = 11.2;
    const float exposureBias = 2.0;
    return uncharted2(x * exposureBias) / uncharted2(vec3(W));
}

vec4 color = HOOKED_texOff(vec2(0.0, 0.0));
vec4 hook() {
    color.rgb = uncharted2_main(color.rgb);
    return color;
}
