//!HOOK MAIN
//!BIND HOOKED
//!DESC Linear Tone Mapping (Luma)

vec3 linear(vec3 x) {
    const float WHITE = 203;
    const float PEAK  = 10000;
	return x * WHITE / PEAK;
}

float luma(vec3 x) {
    // https://en.wikipedia.org/wiki/Relative_luminance
    return dot(x, vec3(0.2126, 0.7152, 0.0722));
}

vec4 color = HOOKED_texOff(vec2(0.0, 0.0));
vec4 hook() {
    const vec3 L = vec3(luma(color.rgb));
    color.rgb *= linear(L) / L;
    return color;
}
