//!HOOK MAIN
//!BIND HOOKED
//!DESC Reinhard Tone Mapping (Luma)

vec3 reinhard(vec3 x) {
    const float L_white = 4.0;  // whitePreserving
    return (x * (1.0 + x / (L_white * L_white))) / (1.0 + x);
}

float luma(vec3 x) {
    // https://en.wikipedia.org/wiki/Relative_luminance
    return dot(x, vec3(0.2126, 0.7152, 0.0722));
}

vec4 color = HOOKED_texOff(vec2(0.0, 0.0));
vec4 hook() {
    const vec3 L = vec3(luma(color.rgb));
    color.rgb *= reinhard(L) / L;
    return color;
}
